%define gecko_version 1.9

%define bootstrap 0
%{?_without_bootstrap: %global bootstrap 0}
%{?_with_bootstrap: %global bootstrap 1}

%define major 1
%define libname %mklibname proxy %major
%define modmanmajor 1
%define libnamemodman %mklibname modman %modmanmajor
%define develname %mklibname -d proxy
Name:           libproxy
Version:        0.4.6
Release:        %mkrel 8
Summary:        A library handling all the details of proxy configuration

Group:          System/Libraries
License:        LGPLv2+
URL:            http://code.google.com/p/libproxy/
# http://code.google.com/p/libproxy/issues/detail?id=130&can=1&q=perl
Source0:        http://%name.googlecode.com/files/%name-%version.tar.gz
Patch0:		libproxy-0.4.6-firefox4.patch
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root

BuildRequires:  cmake
BuildRequires:  python-devel
#perl
BuildRequires:  perl-devel
# gnome
BuildRequires:  libGConf2-devel
%if !%bootstrap
# mozjs
BuildRequires:  xulrunner-devel >= %{gecko_version}
# NetworkManager
#gw disabled, it is in contrib
#BuildRequires:  NetworkManager-devel
BuildRequires:  dbus-glib-devel
# webkit (gtk)
BuildRequires:  webkitgtk-devel
# kde
BuildRequires:	kdelibs4-devel
BuildRequires:  libxmu-devel
%endif
Obsoletes:	libproxy0


%description
libproxy offers the following features:

    * extremely small core footprint (< 35K)
    * no external dependencies within libproxy core
      (libproxy plugins may have dependencies)
    * only 3 functions in the stable external API
    * dynamic adjustment to changing network topology
    * a standard way of dealing with proxy settings across all scenarios
    * a sublime sense of joy and accomplishment 

%package -n %libname
Group:System/Libraries
Summary:        A library handling all the details of proxy configuration
#Virtual Provides - We need either mozjs or WebKit
%if !%bootstrap
Requires: %{name}-pac >= %{version}
%endif
#

%description -n %libname
libproxy offers the following features:

    * extremely small core footprint (< 35K)
    * no external dependencies within libproxy core
      (libproxy plugins may have dependencies)
    * only 3 functions in the stable external API
    * dynamic adjustment to changing network topology
    * a standard way of dealing with proxy settings across all scenarios
    * a sublime sense of joy and accomplishment 

%package -n %libnamemodman
Group:System/Libraries
Summary:        A library handling all the details of proxy configuration

%description -n %libnamemodman
libproxy offers the following features:

    * extremely small core footprint (< 35K)
    * no external dependencies within libproxy core
      (libproxy plugins may have dependencies)
    * only 3 functions in the stable external API
    * dynamic adjustment to changing network topology
    * a standard way of dealing with proxy settings across all scenarios
    * a sublime sense of joy and accomplishment 

%package        utils
Summary:        Binary to test %{name}
Group:          System/Configuration/Networking
Requires:       %{libname} = %{version}-%{release}

%description    utils
The %{name}-utils package contains the proxy binary for %{name}

%package -n python-%name
Summary:        Binding for %{name} and python
Group:          Development/Python
Requires:       %{libname} = %{version}-%{release}

%description -n python-%name
The python-%{name} package contains the python binding for %{name}

%package        perl
Summary:        Perl bindings for %{name}
Group:          Development/Perl
Requires:       %{libname} = %{version}-%{release}

%description    perl
This contains the perl bindings for the libproxy library.

%package        gnome
Summary:        Plugin for %{name} and gnome
Group:          System/Libraries
Requires:       %{libname} = %{version}-%{release}

%description    gnome
The %{name}-gnome package contains the %{name} plugin for gnome.

%if !%bootstrap
%package        kde
Summary:        Plugin for %{name} and kde
Group:          System/Libraries
Requires:       %{libname} = %{version}-%{release}

%description    kde
The %{name}-kde package contains the %{name} plugin for kde.

%package        mozjs
Summary:        Plugin for %{name} and mozjs
Group:          System/Libraries
Requires:       %{libname} = %{version}
#Tweak this according to the current gecko-libs version
Requires:       libxulrunner >= %{gecko_version}
Provides:       %{name}-pac = %{version}-%{release}

%description    mozjs
The %{name}-mozjs package contains the %{name} plugin for mozjs.

%package        webkit
Summary:        Plugin for %{name} and webkit
Group:          System/Libraries
Requires:       %{libname} = %{version}
Provides:       %{name}-pac = %{version}-%{release}

%description    webkit
The %{name}-webkit package contains the %{name} plugin for
webkit.
%endif

%package -n %develname
Summary:        Development files for %{name}
Group:          Development/C
Requires:       %{libname} = %{version}-%{release}
Requires:       %{libnamemodman} = %{version}-%{release}
Provides:	%name-devel = %version-%release

%description -n %develname
The %{name}-devel package contains libraries and header files for
developing applications that use %{name}.


%prep
%setup -q
%patch0 -p0

%build
%if %bootstrap
export CC="gcc -L$(pkg-config --variable sdkdir libxul)/lib"
%endif
%cmake -Dlibexecdir=%_libexecdir -DLIBEXEC_INSTALL_DIR=%_libexecdir \
-DMODULE_INSTALL_DIR=%_libdir/%name/%version/modules \
-DPERL_VENDORINSTALL=1
%make

%install
rm -rf $RPM_BUILD_ROOT
cd build
%makeinstall_std
rm -f %buildroot%_libdir/libproxy/%version/modules/network_networkmanager.so
#gw fix pkgconfig file
sed -i -e "s^Version:.*^Version: %version^" %buildroot%_libdir/pkgconfig/*.pc

%clean
rm -rf $RPM_BUILD_ROOT

%files -n %libname
%defattr(-,root,root,-)
%doc AUTHORS README
%{_libdir}/libproxy.so.%{major}*
%dir %{_libdir}/%{name}
%dir %{_libdir}/%{name}/%{version}
%dir %{_libdir}/%{name}/%{version}/modules

%files -n %libnamemodman
%defattr(-,root,root,-)
%{_libdir}/libmodman.so.%{modmanmajor}*


%files utils
%defattr(-,root,root,-)
%{_bindir}/proxy

%files -n python-%name
%defattr(-,root,root,-)
%{py_platsitedir}/*

%files perl
%defattr(-,root,root,-)
%perl_vendorarch/Net/Libproxy.pm
%perl_vendorarch/auto/Net/Libproxy

%files gnome
%defattr(-,root,root,-)
%{_libdir}/%{name}/%{version}/modules/config_gnome.so
%_libexecdir/pxgconf

%if !%bootstrap
%files kde
%defattr(-,root,root,-)
%{_libdir}/%{name}/%{version}/modules/config_kde4.so

%files mozjs
%defattr(-,root,root,-)
%{_libdir}/%{name}/%{version}/modules/pacrunner_mozjs.so

%files webkit
%defattr(-,root,root,-)
%{_libdir}/%{name}/%{version}/modules/pacrunner_webkit.so
%endif

%files -n %develname
%defattr(-,root,root,-)
%{_includedir}/proxy.h
%{_libdir}/*.so
%{_libdir}/pkgconfig/libproxy-1.0.pc
%_datadir/cmake/Modules/Findlibproxy.cmake




%changelog
* Sun May 15 2011 pterjan <pterjan> 0.4.6-8.mga1
+ Revision: 98944
- Rebuild for fixed find-requires

* Wed Apr 20 2011 pterjan <pterjan> 0.4.6-7.mga1
+ Revision: 89143
- Use upstream fix for firefox 4

  + ennael <ennael>
    - obsoletes libproxy0 (upgrade from mdv)

* Sat Jan 22 2011 pterjan <pterjan> 0.4.6-5.mga1
+ Revision: 33136
- Fix build with firefox 4
- Disbale bootstrap

  + jquelin <jquelin>
    - rebuild

* Sat Jan 15 2011 blino <blino> 0.4.6-3.mga1
+ Revision: 18885
- bootstrap libproxy
- do not build xulrunner and kde plugins in bootstrap
- imported package libproxy


* Wed Nov 03 2010 Götz Waschk <waschk@mandriva.org> 0.4.6-2mdv2011.0
+ Revision: 592881
- rebuild for new python 2.7

* Mon Sep 06 2010 Götz Waschk <waschk@mandriva.org> 0.4.6-1mdv2011.0
+ Revision: 576217
- python module is arch-dependant
- new version
- drop patches
- new libmodman major 1

* Mon Aug 09 2010 Götz Waschk <waschk@mandriva.org> 0.4.4-3mdv2011.0
+ Revision: 568091
- disable bootstrap

* Mon Aug 09 2010 Götz Waschk <waschk@mandriva.org> 0.4.4-2mdv2011.0
+ Revision: 568077
- fix bootstrapping option
- bootstrap build
- fix pkgconfig file

* Mon Aug 09 2010 Götz Waschk <waschk@mandriva.org> 0.4.4-1mdv2011.0
+ Revision: 568003
- new version
- new major
- add libmodman
- drop patches 1,2,3
- fix build
- add perl binding

* Sat Jan 02 2010 Götz Waschk <waschk@mandriva.org> 0.3.1-2mdv2010.1
+ Revision: 485011
- don't apply patch 3 on Cooker, fixes build

* Thu Nov 26 2009 Funda Wang <fwang@mandriva.org> 0.3.1-1mdv2010.1
+ Revision: 470293
- New version 0.3.1
- fix linkage of modules

* Mon Sep 28 2009 Olivier Blin <oblin@mandriva.com> 0.2.3-4mdv2010.0
+ Revision: 450562
- use libxul-unstable headers for jsapi.h, patch from upstream
  http://code.google.com/p/libproxy/issues/detail?id=44
- add bootstrap (from Arnaud Patard)
  fix loop libsoup->libproxy->webkitgtk-devel->libsoup

* Thu Mar 12 2009 Frederik Himpe <fhimpe@mandriva.org> 0.2.3-3mdv2009.1
+ Revision: 354376
- Rebuild for new webkit major

* Tue Feb 03 2009 Götz Waschk <waschk@mandriva.org> 0.2.3-2mdv2009.1
+ Revision: 336801
- remove deps from the library package

* Mon Feb 02 2009 Götz Waschk <waschk@mandriva.org> 0.2.3-1mdv2009.1
+ Revision: 336716
- fix deps
- import libproxy


* Mon Feb  2 2009 Götz Waschk <waschk@mandriva.org> 0.2.3-1mdv2009.1
- initial package based on Fedora

* Thu Jan 22 2009 kwizart < kwizart at gmail.com > - 0.2.3-8
- Merge NetworkManager module into the main libproxy package
- Main Requires the -python and -bin subpackage 
 (splitted for multilibs compliance).

* Fri Oct 24 2008 kwizart < kwizart at gmail.com > - 0.2.3-7
- Disable Gnome/KDE default support via builtin modules.
 (it needs to be integrated via Gconf2/neon instead).

* Tue Oct 21 2008 kwizart < kwizart at gmail.com > - 0.2.3-6
- Disable Obsoletes.
- Requires ev instead of evr for optionnals sub-packages.

* Tue Oct 21 2008 kwizart < kwizart at gmail.com > - 0.2.3-5
- Use conditionals build.

* Mon Sep 15 2008 kwizart < kwizart at gmail.com > - 0.2.3-4
- Remove plugin- in the name of the packages

* Mon Aug  4 2008 kwizart < kwizart at gmail.com > - 0.2.3-3
- Move proxy.h to libproxy/proxy.h
  This will prevent it to be included in the default include path
- Split main to libs and util and use libproxy to install all

* Mon Aug  4 2008 kwizart < kwizart at gmail.com > - 0.2.3-2
- Rename binding-python to python
- Add Requires: gecko-libs >= %%{gecko_version}
- Fix some descriptions
- Add plugin-webkit package
 
* Fri Jul 11 2008 kwizart < kwizart at gmail.com > - 0.2.3-1
- Convert to Fedora spec

* Fri Jun 6 2008 - dominique-rpm@leuenberger.net
- Updated to version 0.2.3
* Wed Jun 4 2008 - dominique-rpm@leuenberger.net
- Extended spec file to build all available plugins
* Tue Jun 3 2008 - dominique-rpm@leuenberger.net
- Initial spec file for Version 0.2.2

